/*----------------------------------------------------------------------------*/
/*
    : size.c
    :    (  )
     :  .., .
      : 21.07.08-01:27
*/
/*----------------------------------------------------------------------------*/
#ifndef size_c_E
#define size_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
/*----------------------------------------------------------------------------*/
/*
      .
*/
void stdword_size(struct fws* ws)
    {
	vcode vmean;
	fword* w;
	int size=0;
	if(from_vstk(ws, &vmean)>=0)
	    {	
		if(ISCONST(&vmean))
		    {
			switch(vmean.type)
			    {
				case WTYPE_CINT:{size = sizeof(int);break;}
				case WTYPE_CREAL:{size = sizeof(float);break;}
				case WTYPE_CSTR:{size = strlen(vmean.svar)+1;break;}
			    }
			clear_vcode(&vmean);
		    }
		else{w = get_nword(ws,vmean.word);size = w->size;}
		vmean.type = WTYPE_CINT;
		vmean.ivar = size;
		to_vstk(ws, &vmean);
	    }
    }
/*----------------------------------------------------------------------------*/
#endif /* size_c_E */
