/*----------------------------------------------------------------------------*/
/*
    : compil.c
    :  
     :  .., .
      : 10.03.08-23:59
*/
/*----------------------------------------------------------------------------*/
#ifndef compil_c_E
#define compil_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
#include <string.h>
#include <string.h>
#include <stdlib.h>
#include <debug.h>
/*----------------------------------------------------------------------------*/
/*
        
       .
*/
int do_compile_add(fws* ws, struct vcode* vmcode)
    {
	fword* w = ws->cword;
	struct vcode* v=w->vmcode;
	int i=0;
	//     .
	if(v){while(GETFASTCMD(v)!=FCMD_ENDVM){v++;i++;}}
	// 
	if(v = realloc(w->vmcode,(i+2)*sizeof(vcode)))
	    {
		memcpy(v+i,vmcode,sizeof(vcode));
		SETFASTCMD(v+(i+1),FCMD_ENDVM);
	    }
	else
	    {SETERROR(ws,AFER_NOMEMORY);return(-1);}
	w->vmcode = v;
	dmsg("Add vmcode to [%s] 0x%x 0x%x\n",w->name,(w->vmcode + i)->type,(w->vmcode + i + 1)->type);
	//
	return(0);
    }
/*----------------------------------------------------------------------------*/
int do_lexem_compile(fws* ws, int lextype)
    {
	struct vcode v={0,0};
	//
	switch (lextype)
	    {
		//  
		case LEXT_CINT:
		    {
			STYPE(&v,WTYPE_CINT);
			v.ivar = ws->ivar;
			do_compile_add(ws, &v);
			break;
		    }
		case LEXT_CREAL:
		    {
			STYPE(&v,WTYPE_CREAL);
			v.fvar = ws->fvar;
			do_compile_add(ws, &v);
			break;
		    }
		case LEXT_CSTR:
		    {
			STYPE(&v,WTYPE_CSTR);
			v.svar = strdup(ws->svar);
			do_compile_add(ws, &v);
			break;
		    }
		// 
		case LEXT_WORD:
		    {
			fword* w=get_nword(ws, ws->word);
			//   .
			if(w->type & INTERP_ONLY)
			    {
				do_lexem(ws, lextype);
				break;
			    }
			//  
			v.type=GTYPE(w);
			v.word=ws->word;
			do_compile_add(ws, &v);
			break;
		    }
		case LEXT_UNKNOWN:{SETERROR(ws,AFER_UWORD);break;}
	    }
	return(0);
    }
/*----------------------------------------------------------------------------*/
#endif /* compil_c_E */
