/*----------------------------------------------------------------------------*/
/*
    : sstk.c
    :    
		    .
     :  .., .
      : 10.03.08-14:27
*/
/*----------------------------------------------------------------------------*/
#ifndef sstk_c_E
#define sstk_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
#include <string.h>
#include <stdlib.h>
#include <debug.h>
#include <sstk.h>
/*----------------------------------------------------------------------------*/
/*
     sstk
*/
int init_sstk(struct fws* ws)
    {
	ws->sstk = malloc(SSTK_SIZE*sizeof(unsigned int));
	if(ws->sstk){dmsg("sstk \n");ws->sstk_top=-1;}
	else{dmsg("sstk  \n");return(-1);}
	ws->sstk_top=-1;
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
     sstk
*/
int done_sstk(struct fws* ws)
    {
	free(ws->sstk);
	ws->sstk =NULL;
	dmsg("sstk ̣\n");
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
        .
    -1 - 
     0 -ӣ  
*/
int to_sstk(struct fws* ws, unsigned int smean)
    {
	if(ws->sstk_top >= (SSTK_SIZE-1))
	    {
		//SETERROR(ws,AFER_SSTKOVF);
		return(-1);
	    }
	else
	    {
		ws->sstk_top ++;
		ws->sstk[ws->sstk_top] = smean;
	    }
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
        
    -1 - 
     0 -ӣ  ,  radr -   
*/
int from_sstk(struct fws* ws, unsigned int* smean)
    {
	if(ws->sstk_top < 0)
	    {
		//SETERROR(ws,AFER_SSTKEMPTY);
		return(-1);
	    }
	else
	    {
		*smean = ws->sstk[ws->sstk_top];
		ws->sstk_top--;
	    }
	return(0);
    }
/*----------------------------------------------------------------------------*/
#endif /* sstk_c_E */
