/*----------------------------------------------------------------------------*/
/*
    : vstk.h
    :    
     :  .., .
      : 10.03.08-14:52
*/
/*----------------------------------------------------------------------------*/
#ifndef vstk_h_E
#define vstk_h_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
/*----------------------------------------------------------------------------*/
/*
     vstk
*/
int init_vstk(struct fws* ws);
/*----------------------------------------------------------------------------*/
/*
     vstk.
*/
int clear_vstk(struct fws* ws);
/*----------------------------------------------------------------------------*/
/*
     vstk
*/
int done_vstk(struct fws* ws);
/*----------------------------------------------------------------------------*/
/*
        
    -1 - 
     0 -ӣ  
*/
int to_vstk(struct fws* ws, struct vcode* radr);
/*----------------------------------------------------------------------------*/
/*
        .
    -1 - 
     0 -ӣ  ,  radr -   
               
      clear_vcode()
*/
int from_vstk(struct fws* ws, struct vcode* radr);
/*----------------------------------------------------------------------------*/
/*
      (  )
*/
void clear_vcode(struct vcode* vmean);
/*----------------------------------------------------------------------------*/
/*
      -  .
*/
int cint_to_vstk(struct fws* ws, int mean);
/*----------------------------------------------------------------------------*/
/*
      -  .
*/
int creal_to_vstk(struct fws* ws, float mean);
/*----------------------------------------------------------------------------*/
/*
      -  .
*/
int cstr_to_vstk(struct fws* ws, char* mean);
/*----------------------------------------------------------------------------*/
/*
      .
    n -    
*/
int var_to_vstk(struct fws* ws, int n);
/*----------------------------------------------------------------------------*/
/*
         .
      .
        
*/
int get_local_copy(struct fws* ws, struct vcode* vmean);
/*----------------------------------------------------------------------------*/
/*
         .
       -  -1,  -  
*/
int ftypecast(struct vcode* v1, struct vcode* v2);
/*----------------------------------------------------------------------------*/
/*
        .
       -  -1,  -  
*/
int ftypecasto(struct vcode* v1, int type);
/*----------------------------------------------------------------------------*/
/*
        ,   disp   (0 - )
      NULL  
*/
struct vcode* top_vstk(struct fws* ws,int disp);
/*----------------------------------------------------------------------------*/
/*
        disp   (0 - )
      .
*/
int dup_vstk(struct fws* ws, int disp);
/*----------------------------------------------------------------------------*/
#endif /* vstk_h_E */
