/*----------------------------------------------------------------------------*/
/*
    : wspc.c
    :  
     :  .., .
      : 10.03.08-15:26
*/
/*----------------------------------------------------------------------------*/
#ifndef wspc_c_E
#define wspc_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
#include <string.h>
#include <stdlib.h>
#include <debug.h>
/*----------------------------------------------------------------------------*/
/*
      -
*/
fws* wspc_init()
    {
	#ifdef ARCH_INIT_MAC
	    ARCH_INIT_MAC();
	#endif /* ARCH_INIT_MAC */
	//
	fws* retval=malloc(sizeof(fws));
	if(retval)
	    {
		dmsg("Workspace init\n");
		memset(retval,0,sizeof(fws));
		init_rstk(retval);
		init_vstk(retval);
		init_sstk(retval);
		init_dict(retval);
	    }
	return(retval);
    }
/*----------------------------------------------------------------------------*/
/*
      -
*/
void _wspc_done(fws* ws)
    {
	done_rstk(ws);
	done_vstk(ws);
	done_sstk(ws);
	done_dict(ws);
	free(ws);
	//
	#ifdef ARCH_DONE_MAC
	    ARCH_DONE_MAC();
	#endif /* ARCH_DONE_MAC */
	//
	dmsg("Workspace done\n");
    }
/*----------------------------------------------------------------------------*/
#endif /* wspc_c_E */
