/*----------------------------------------------------------------------------*/
/*
    : ariphmetic.c
    : -  
     :  .., .
      : 21.07.08-01:11
*/
/*----------------------------------------------------------------------------*/
#ifndef ariphmetic_c_E
#define ariphmetic_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
/*----------------------------------------------------------------------------*/
/*  + */
void stdword_add(struct fws* ws)
    {
	two_op_pramble_z();
	int t;
	if((t=ftypecast(&v1, &v2))>=0)
	    {
		/*    -   */
		switch(t)
		    {
			case WTYPE_CINT:{v1.ivar = v1.ivar+v2.ivar; break;}
			case WTYPE_CREAL:{v1.fvar = v1.fvar+v2.fvar; break;}
			case WTYPE_CSTR:
			    {
				int l1 = strlen(v1.svar);
				int l2 = strlen(v2.svar);
				v1.svar = realloc(v1.svar,l1+l2+1);
				strcpy(v1.svar + l1,v2.svar);
				break;
			    }
			case WTYPE_ARRAY:{SETERROR(ws,AFER_INVTYPES);break;}
		    }
	    }
	else
	    {
		/*   +  */
		if((v1.type==WTYPE_CINT)&&(v2.type==WTYPE_CSTR))
		    {
			int l2 = strlen(v2.svar)+1;
			char* s=malloc(l2+1);
			strcpy(s+1,v2.svar);
			*(s+0) = v1.ivar;
			clear_vcode(&v1);
			clear_vcode(&v2);
			v1.type = WTYPE_CSTR;
			v1.svar = s;
			v2.type = WTYPE_CINT;
			
		    }
		/*   +  */
		if((v1.type==WTYPE_CSTR)&&(v2.type==WTYPE_CINT))
		    {
			int l1 = strlen(v1.svar);
			char* s=malloc(l1+2);
			strcpy(s+0,v1.svar);
			*(s+l1) = v2.ivar;
			*(s+l1+1) ='\0';
			clear_vcode(&v1);
			clear_vcode(&v2);
			v1.type = WTYPE_CSTR;
			v1.svar = s;
			v2.type = WTYPE_CINT;
			
		    }
	    }
	//
	to_vstk(ws, &v1);
	clear_vcode(&v2);
	//
    }
/*----------------------------------------------------------------------------*/
/*  - */
void stdword_sub(struct fws* ws)
    {
	two_op_pramble();
	//
	switch(t)
	    {
		case WTYPE_CINT:{v1.ivar = v1.ivar-v2.ivar; break;}
		case WTYPE_CREAL:{v1.fvar = v1.fvar-v2.fvar; break;}
		case WTYPE_ARRAY:
		case WTYPE_CSTR:{SETERROR(ws,AFER_OPUNDTYPES);break;}
	    }
	//
	clear_vcode(&v2);
	if(ws->error){clear_vcode(&v1);}else{to_vstk(ws, &v1);}
	//
    }
/*----------------------------------------------------------------------------*/
/*  * */
void stdword_mul(struct fws* ws)
    {
	two_op_pramble();
	//
	switch(t)
	    {
		case WTYPE_CINT:{v1.ivar = v1.ivar*v2.ivar; break;}
		case WTYPE_CREAL:{v1.fvar = v1.fvar*v2.fvar; break;}
		case WTYPE_ARRAY:
		case WTYPE_CSTR:{SETERROR(ws,AFER_OPUNDTYPES);break;}
	    }
	//
	clear_vcode(&v2);
	if(ws->error){clear_vcode(&v1);}else{to_vstk(ws, &v1);}
	//
    }
/*----------------------------------------------------------------------------*/
/*  / */
void stdword_div(struct fws* ws)
    {
	two_op_pramble();
	//
	switch(t)
	    {
		case WTYPE_CINT:{v1.ivar = v1.ivar/v2.ivar; break;}
		case WTYPE_CREAL:{v1.fvar = v1.fvar/v2.fvar; break;}
		case WTYPE_ARRAY:
		case WTYPE_CSTR:{SETERROR(ws,AFER_OPUNDTYPES);break;}
	    }
	//
	clear_vcode(&v2);
	if(ws->error){clear_vcode(&v1);}else{to_vstk(ws, &v1);}
	//
    }
/*----------------------------------------------------------------------------*/
#endif /* ariphmetic_c_E */
