/*----------------------------------------------------------------------------*/
/*
    : compare.c
    :     = < >
     :  .., .
      : 21.07.08-01:15
*/
/*----------------------------------------------------------------------------*/
#ifndef compare_c_E
#define compare_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
/*----------------------------------------------------------------------------*/
/*  = */
void stdword_equal(struct fws* ws)
    {
	two_op_pramble();
	//
	int cond=0;
	//
	switch(t)
	    {
		case WTYPE_CINT:{if(v1.ivar==v2.ivar){cond=1;} break;}
		case WTYPE_CREAL:{if(v1.fvar==v2.fvar){cond=1;} break;}
		case WTYPE_CSTR:{if(!strcmp(v1.svar,v2.svar)){cond=1;}break;}
		case WTYPE_ARRAY:{SETERROR(ws,AFER_INVTYPES);break;}
	    }
	//
	clear_vcode(&v2);
	clear_vcode(&v1);
	//
	v1.type = WTYPE_CINT;
	v1.ivar = cond;
	//
	to_vstk(ws, &v1);
    }
/*----------------------------------------------------------------------------*/
/*  < () */
void stdword_lo(struct fws* ws)
    {
	two_op_pramble();
	//
	int cond=0;
	//
	switch(t)
	    {
		case WTYPE_CINT:{if(v1.ivar<v2.ivar){cond=1;} break;}
		case WTYPE_CREAL:{if(v1.fvar<v2.fvar){cond=1;} break;}
		case WTYPE_CSTR:{if(strcmp(v1.svar,v2.svar)<0){cond=1;}break;}
		case WTYPE_ARRAY:{SETERROR(ws,AFER_INVTYPES);break;}
	    }
	//
	clear_vcode(&v2);
	clear_vcode(&v1);
	//
	v1.type = WTYPE_CINT;
	v1.ivar = cond;
	//
	to_vstk(ws, &v1);
    }
/*----------------------------------------------------------------------------*/
/*  > () */
void stdword_gt(struct fws* ws)
    {
	two_op_pramble();
	//
	int cond=0;
	//
	switch(t)
	    {
		case WTYPE_CINT:{if(v1.ivar>v2.ivar){cond=1;} break;}
		case WTYPE_CREAL:{if(v1.fvar>v2.fvar){cond=1;} break;}
		case WTYPE_CSTR:{if(strcmp(v1.svar,v2.svar)>0){cond=1;}break;}
		case WTYPE_ARRAY:{SETERROR(ws,AFER_INVTYPES);break;}
	    }
	//
	clear_vcode(&v2);
	
	//
	v1.type = WTYPE_CINT;
	v1.ivar = cond;
	//
	to_vstk(ws, &v1);
    }
/*----------------------------------------------------------------------------*/
#endif /* compare_c_E */
