/*----------------------------------------------------------------------------*/
/*
    : logops.c
    : -  
     :  .., .
      : 21.07.08-01:11
*/
/*----------------------------------------------------------------------------*/
#ifndef logops_c_E
#define logops_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
/*----------------------------------------------------------------------------*/
#define LOGOP_AND	0
#define LOGOP_OR	1
/*  */
void stdword_logops_all(struct fws* ws, int op)
    {
	two_op_pramble();
	//
	if((v1.type != WTYPE_CINT)||(v2.type != WTYPE_CINT)){SETERROR(ws,AFER_INVTYPES);}
	else
	    {
		switch(op)
		    {
			case LOGOP_AND:{v1.ivar=(v1.ivar) && (v2.ivar);break;}
			case LOGOP_OR: {v1.ivar=(v1.ivar) || (v2.ivar);break;}
		    }
		to_vstk(ws, &v1);
	    }
	//
	clear_vcode(&v1);
	clear_vcode(&v2);
	//
    }
/*----------------------------------------------------------------------------*/
void stdword_land(struct fws* ws){stdword_logops_all(ws, LOGOP_AND);}
void stdword_lor(struct fws* ws){stdword_logops_all(ws, LOGOP_OR);}
//
void stdword_lnot(struct fws* ws)
    {
	one_op_pramble();
	if(v1.type!=WTYPE_CINT){SETERROR(ws,AFER_INVTYPES);}
	else
	    {
		v1.ivar = !(v1.ivar);
		to_vstk(ws, &v1);
	    }
	clear_vcode(&v1);
    }
/*----------------------------------------------------------------------------*/
#endif /* logops_c_E */
