/*----------------------------------------------------------------------------*/
/*
    : debug.c
    :  
     :  .., .
      : 10.03.08-14:13
*/
/*----------------------------------------------------------------------------*/
#ifndef debug_c_E
#define debug_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
#include <string.h>
#include <stdlib.h>
#include <debug.h>
/*----------------------------------------------------------------------------*/
void dbg_verbose(int code)
    {
	int i=0;
	while(error_strings[i].code>=0)
	    {
		if(error_strings[i].code == code)
		    {
			printf("Error %i: %s\n",error_strings[i].code,error_strings[i].str);
		    }
		i++;
	    }
    }
/*----------------------------------------------------------------------------*/
void dbg_wordinfo(fword* word)
    {
	switch(GTYPECI(word))
	    {
		case WTYPE_INT:{dmsg("word: %s t:INT %i\n",word->name,word->ivar);break;}
		case WTYPE_REAL:{dmsg("word: %s t:REAL %f\n",word->name,word->fvar);break;}
		case WTYPE_STR:{dmsg("word: %s t:STR %s\n",word->name,word->svar);break;}
		case WTYPE_NATIVE:{dmsg("word: %s t:NATIVE PROC \n",word->name);break;}
		case WTYPE_VIRTUAL:{dmsg("word: %s t:VIRTUAL PROC \n",word->name);break;}
		case WTYPE_ARRAY:{dmsg("word: %i t:ARRAY \n",word->size);break;}
	    }
    }
/*----------------------------------------------------------------------------*/
char* dbg_strerror(int code)
    {
	int i=0;
	while(error_strings[i].code>=0)
	    {
		if(error_strings[i].code == code)
		    {
			return(error_strings[i].str);
		    }
		i++;
	    }
	return(NULL);
    }
/*----------------------------------------------------------------------------*/
#endif /* debug_c_E */
