/*----------------------------------------------------------------------------*/
/*
    : errors.c
    : _
     :  .., .
      : 03.08.08-01:04
*/
/*----------------------------------------------------------------------------*/
#ifndef errors_c_E
#define errors_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
#include <string.h>
#include <stdlib.h>
#include <debug.h>
/*----------------------------------------------------------------------------*/
/*
     -   .
     , :
    1.   "onerror".    , :
	.     .
	.  .
	.   .
	.   ,      onerror.
	.  .
*/
void onerror(fws* ws)
    {
	int errcode=ws->error;
	fword* w;
	vcode vmean;
	//
	if(errcode)
	    {
		// 
		w=find_word(ws, "onerror");
		// 
		if(w)
		    {
			ws->error = 0;
			vmean.type = WTYPE_CINT;
			vmean.ivar = errcode;
			to_vstk(ws, &vmean);
			switch (GTYPEI(w))
			    {
				// 
				case WTYPE_NATIVE:{if(w->ncode){w->ncode(ws);}break;}
				case WTYPE_VIRTUAL:{run_vm_cmd(ws, w->vmcode);break;}
			    }
			if(get_local_copy(ws,&vmean)<0){return;}
			if(vmean.type != WTYPE_CINT){SETERROR(ws,AFER_OPUNDTYPES);clear_vcode(&vmean);return;}
			ws->error = vmean.ivar;
		    }
	    }
    }
/*----------------------------------------------------------------------------*/
#endif /* errors_c_E */
