/*----------------------------------------------------------------------------*/
/*
    : inpstream.c
    :      
     :  .., .
      : 10.03.08-16:37
*/
/*----------------------------------------------------------------------------*/
#ifndef inpstream_c_E
#define inpstream_c_E
/*----------------------------------------------------------------------------*/
/*
#undef  DEBUGLEVEL
#define DEBUGLEVEL 3
*/
/*----------------------------------------------------------------------------*/
#include <aforth.h>
#include <string.h>
#include <stdlib.h>
#include <debug.h>
#include <rstk.h>
/*----------------------------------------------------------------------------*/
/*
      
    pstr    (    )  .
      .
*/
int miss_blanks(char** pstr)
    {
	while(isblank(**pstr)&&(**pstr)){(*pstr)++;}
	return(**pstr);
    }
/*----------------------------------------------------------------------------*/
/*
      
    pstr    (    )  .
      .
*/
int miss_nonblanks(char** pstr)
    {
	while((!isblank(**pstr))&&(**pstr)){(*pstr)++;}
	return(**pstr);
    }
/*----------------------------------------------------------------------------*/
void delchar(char* s)
    {
	while(1){*s = *(s+1);if(!*s){break;}s++;}
    }
/*----------------------------------------------------------------------------*/
/*
         .
     -     -1,    
*/
int get_next_word(fws* ws)
    {
	//   .
	int ch = miss_blanks(&(ws->curchar));
	char* chs = ws->curchar; //  .
	if(!ch){return(-1);} //   .
	//
	unsigned int err=0;
	// 
	if(ch=='\'')
	    {
		(ws->curchar)++;
		//
		if(*(ws->curchar) == '\\')
		    {
			switch(*((ws->curchar)+1))
			    {
				case 't':{*(ws->curchar+1)='\t';break;}
				case 'n':{*(ws->curchar+1)='\n';break;}
				case 'r':{*(ws->curchar+1)='\r';break;}
				case '\\':{*(ws->curchar+1)='\\';break;}
			    }
			(ws->curchar)++;
		    }
		//
		if((*(ws->curchar+1))=='\'')
		    {
			//    
			ws->ivar = ((unsigned char)(*(ws->curchar)));
			ws->curchar++;ws->curchar++;
			dmsg(" 0x%X\n",ws->ivar);
			return(LEXT_CINT);
		    }
		else
		    {
			//  !    
			ws->unknown = chs;
			dmsg("  %s\n",ws->unknown);
			return(LEXT_UNKNOWN);
		    }
		//
	    }
	// 
	else if(ch=='"')
	    {
		ws->curchar++;
		chs++;
		//
		while(*(ws->curchar) != '"')
		    {
			if(*(ws->curchar) == '\\')
			    {
				switch(*((ws->curchar)+1))
				    {
					case 't':{*(ws->curchar)='\t';delchar((ws->curchar)+1);break;}
					case 'n':{*(ws->curchar)='\n';delchar((ws->curchar)+1);break;}
					case 'r':{*(ws->curchar)='\r';delchar((ws->curchar)+1);break;}
					case '\\':{*(ws->curchar)='\\';delchar((ws->curchar)+1);break;}
					default:
					    {
						delchar((ws->curchar));
						if(*(ws->curchar)){(ws->curchar)++;}
					    }
				    }
			    }
			if(!(*(ws->curchar))){break;}
			(ws->curchar)++;
		    }
		//    
		if((*(ws->curchar))=='"'){*(ws->curchar)='\0';(ws->curchar)++;}
		else
		    {
			//  !    
			ws->unknown = chs;
			dmsg("  %s\n",ws->unknown);
			return(LEXT_UNKNOWN);
		    }
		//
		ws->svar = chs;
		dmsg(" %s\n",ws->svar);
		return(LEXT_CSTR);
	    }
	else
	    {
		/*    */
		ch = miss_nonblanks(&(ws->curchar));
		/*   ,   */
		if(ch){*(ws->curchar)='\0';ws->curchar++;}
		/* */
		dmsg("%s\n",chs);
		/*   .*/
		if((ws->word = find_nword(ws, chs))>=0)
		    {
			dmsg("   %i\n",ws->word);
			return(LEXT_WORD);
		    }
		/*  ? */
		else if(isdigit(chs[0]))
		    {
			if(((chs[1]=='x')||(chs[1]=='X'))&&(chs[0]=='0'))
			    {
				// 
				unsigned int k=0;
				char* c=chs+2;
				while(*c)
				    {
					k = k << 4;
					if((*c >='0')&&(*c <='9')){k = k | (*c -'0');}
					else if((*c >='A')&&(*c <='F')){k = k | (*c -'A' + 10);}
					else if((*c >='a')&&(*c <='f')){k = k | (*c -'a' + 10);}
					else {err=1;break;}
					c++;
				    }
				if(!err)
				    {
					ws->ivar = k;
					dmsg(" 0x%X\n",ws->ivar);
					return(LEXT_CINT);
				    }
			    }
			else 
			    {
				// 
				unsigned int k=0;
				char* c=chs;
				while(*c)
				    {
					k = (k << 1) + (k << 3); // k=k*10
					if((*c >='0')&&(*c <='9')){k = k + (*c -'0');}
					else {err=1;break;}
					c++;
				    }
				if(!err)
				    {
					ws->ivar = k;
					dmsg(" %i\n",ws->ivar);
					return(LEXT_CINT);
				    }
			    }
			/*  ? */
			if(isdigit(chs[0])||(chs[0]=='.'))
			    {
				char* e=NULL;
				ws->fvar = (float)strtod(chs, &e);
				if(!*e)
				    {
					dmsg(" %f\n",ws->fvar);
					return(LEXT_CREAL);
				    }
			    }
		    }
		/*  */
		ws->unknown = chs;
		dmsg("  %s\n",ws->unknown);
		return(LEXT_UNKNOWN);
	    }
	if(*(ws->curchar)){return(0);}
	return(-1);
    }
/*----------------------------------------------------------------------------*/
/*
       .
*/
int parse_line(fws* ws)
    {
	int wtype=0;
	ws->curchar = ws->inbuf;
	//
	while((wtype=get_next_word(ws))>=0)
	    {
		//  
		if(wtype==LEXT_UNKNOWN)
		    {
			if(!strncmp(ws->unknown,"(",1))
			    {
				ws->rem_counter++;
			    }
		    }
		//    -   .
		if(!(ws->rem_counter))
		    {
			//  -  -.
			if(ws->flags & FWS_CONSTARRAY)
			    {
				add_array_elem(ws,wtype);
				//   
				if(ws->error){free(ws->array);ws->array=NULL;}
			    }
			//   
			else if(ws->flags & FWS_COMPILE)
			    {
				do_lexem_compile(ws, wtype);
				//      -   .
				//      
				if(ws->error){delete_last_word(ws);ws->flags &= ~(FWS_COMPILE);}
			    }
			//   .
			else
			    {
				do_lexem(ws, wtype);
			    }
		    }
		//  
		if(wtype==LEXT_UNKNOWN)
		    {
			if(!strncmp(ws->unknown,")",1))
			    {
				ws->rem_counter--;
			    }
		    }
		//
		onerror(ws); //    
		// ,    .
		if(ws->error){break;}
	    }
	//
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
     .
*/
int do_file(fws* ws, char* fname)
    {
	FILE* f = fopen(fname,"r");
	char* ch;
	int line=0;
	int retval=0;
	//
	if(!f)
	    {
		SETERROR(ws,AFER_FNOTOPEN);
		printf("%s: ",fname);dbg_verbose(ws->error);
		return(-1);
	    }
	//
	ws->rem_counter=0;
	//
	while(fgets(ws->inbuf,MAXLINESIZE,f))
	    {
		ch=NULL;
		if(ch = strchr(ws->inbuf,'\n')){*ch = '\0';}
		dmsg("%s\n",ws->inbuf);
		parse_line(ws);
		if(ws->error)
		    {
			printf("%s:  %i. ",fname,line+1);dbg_verbose(ws->error);
			retval=-(line+1);
			break;
		    }
		line++;
	    }
	//
	ws->rem_counter=0;
	//
	fclose(f);
	return(retval);
    }
/*----------------------------------------------------------------------------*/
#endif /* inpstream_c_E */
